<?php
/*
 Plugin Name: XML Google Maps
 Plugin URI: http://www.matusz.ch/blog/projekte/xml-google-maps-wordpress-plugin/
 Feed URI: http://www.matusz.ch/blog/tags/xml-google-maps-wp-plugin/feed/
 Description: This plugin allows you to easily insert Google Map or Google Earth Plugin Maps into your blog. Supports KML, KMZ, GPX, geoRSS filelinks. Supports Default, Satellite, Hybrid, Physical and Google Earth Plugin Maptypes
 Version: 1.10.2
 Author: Patrick Matusz
 Author URI: http://www.matusz.ch/blog/
 */

global $wpdb;

$wpdb->xmlgooglemapsdb = $table_prefix . 'xmlgooglemaps';

// Defining Options
define("key_xmlgm_uid", "xmlgm_uid", true);
define("xmlgm_uid_default", "(none)", true);
define("key_xmlgm_width", "xmlgm_width", true);
define("xmlgm_width_default", "664", true);
define("key_xmlgm_height", "xmlgm_height", true);
define("xmlgm_height_default", "400", true);
define("key_xmlgm_align", "xmlgm_align", true);
define("xmlgm_align_default", "left", true);
define("key_xmlgm_urldisplaymode", "xmlgm_urldisplaymode", true);
define("xmlgm_urldisplaymode_default", "title", true);
define("key_xmlgm_viewstyle", "xmlgm_viewstyle", true);
define("xmlgm_viewstyle_default", "G_NORMAL_MAP", true);
define("key_xmlgm_panzoomcontrol", "xmlgm_panzoomcontrol", true);
define("xmlgm_panzoomcontrol_default", "large", true);
define("key_xmlgm_overviewmap", "xmlgm_overviewmap", true);
define("xmlgm_overviewmap_default", "hide", true);
define("key_xmlgm_scalecontrol", "xmlgm_scalecontrol", true);
define("xmlgm_scalecontrol_default", "hide", true);
define("key_xmlgm_maptypecontrol", "xmlgm_maptypecontrol", true);
define("xmlgm_maptypecontrol_default", "show", true);
define("key_xmlgm_mapnorm", "xmlgm_mapnorm", true);
define("xmlgm_mapnorm_default", "show", true);
define("key_xmlgm_maphyb", "xmlgm_maphyb", true);
define("xmlgm_maphyb_default", "show", true);
define("key_xmlgm_mapsat", "xmlgm_mapsat", true);
define("xmlgm_mapsat_default", "show", true);
define("key_xmlgm_mapphy", "xmlgm_mapphy", true);
define("xmlgm_mapphy_default", "hide", true);
define("key_xmlgm_mapearth", "xmlgm_mapearth", true);
define("xmlgm_mapearth_default", "hide", true);
define("key_xmlgm_dragging", "xmlgm_dragging", true);
define("xmlgm_dragging_default", "enabled", true);
define("key_xmlgm_doubleClickZoom", "xmlgm_doubleClickZoom", true);
define("xmlgm_doubleClickZoom_default", "enabled", true);
define("key_xmlgm_continuousZoom", "xmlgm_continuousZoom", true);
define("xmlgm_continuousZoom_default", "enabled", true);
define("key_xmlgm_googleBar", "xmlgm_googleBar", true);
define("xmlgm_googleBar_default", "disabled", true);
define("key_xmlgm_scrollWheelZoom", "xmlgm_scrollWheelZoom", true);
define("xmlgm_scrollWheelZoom_default", "enabled", true);
define("key_xmlgm_elevationmeasurement", "xmlgm_elevationmeasurement", true);
define("xmlgm_elevationmeasurement_default", "metric", true);
define("key_xmlgm_speedscale", "xmlgm_speedscale", true);
define("xmlgm_speedscale_default", "level2", true);

//KML Parsing
define("key_xmlgm_kmlparsing", "xmlgm_kmlparsing", true);
define("xmlgm_kmlparsing_default", "enabled", true);

//GPX Options
define("key_xmlgm_linecolor", "xmlgm_linecolor", true);
define("xmlgm_linecolor_default", "#0000FF", true);
define("key_xmlgm_linewidth", "xmlgm_linewidth", true);
define("xmlgm_linewidth_default", "5", true);
define("key_xmlgm_lineopacity", "xmlgm_lineopacity", true);
define("xmlgm_lineopacity_default", "50", true);
define("key_xmlgm_gpxview", "xmlgm_gpxview", true);
define("xmlgm_gpxview_default", "all", true);
define("key_xmlgm_gpxcssstyle", "xmlgm_gpxcssstyle", true);
define("xmlgm_gpxcssstyle_default", "font-family: Verdana, Arial, Sans-Serif;", true);
define("key_xmlgm_gpxdirectopenwplink", "xmlgm_gpxdirectopenwplink", true);
define("xmlgm_gpxdirectopenwplink_default", "dblclick", true);

//Elevation Options
define("key_xmlgm_elevationheight", "xmlgm_elevationheight", true);
define("xmlgm_elevationheight_default", "200", true);
define("key_xmlgm_elevlinecolor", "xmlgm_elevlinecolor", true);
define("xmlgm_elevlinecolor_default", "#0000FF", true);
define("key_xmlgm_elevationchart", "xmlgm_elevationchart", true);
define("xmlgm_elevationchart_default", "show", true);
define("key_xmlgm_elelinewidth", "xmlgm_elelinewidth", true);
define("xmlgm_elelinewidth_default", "5", true);
define("key_xmlgm_elevationtitle", "xmlgm_elevationtitle", true);
define("xmlgm_elevationtitle_default", "Elevation Profile", true);

//Speed Options
define("key_xmlgm_speedheight", "xmlgm_speedheight", true);
define("xmlgm_speedheight_default", "200", true);
define("key_xmlgm_speedlinecolor", "xmlgm_speedlinecolor", true);
define("xmlgm_speedlinecolor_default", "#0000FF", true);
define("key_xmlgm_speedchart", "xmlgm_speedchart", true);
define("xmlgm_speedchart_default", "hide", true);
define("key_xmlgm_speedlinewidth", "xmlgm_speedlinewidth", true);
define("xmlgm_speedlinewidth_default", "5", true);
define("key_xmlgm_speedcharttitle", "xmlgm_speedcharttitle", true);
define("xmlgm_speedcharttitle_default", "Speed Profile", true);

//Check Point Options
define("key_xmlgm_checkpointmapmarkercolor", "xmlgm_checkpointmapmarkercolor", true);
define("xmlgm_checkpointmapmarkercolor_default", "red", true);
define("key_xmlgm_checkpointtable", "xmlgm_checkpointtable", true);
define("xmlgm_checkpointtable_default", "hide", true);
define("key_xmlgm_checkpointinterval", "xmlgm_checkpointinterval", true);
define("xmlgm_checkpointinterval_default", "0", true);

//Templates
define("key_xmlgm_checkpointtabletempl", "xmlgm_checkpointtabletempl", true);
define("xmlgm_checkpointtabletempl_default", "", true);
define("key_xmlgm_checkpointtablerowtempl", "xmlgm_checkpointtablerowtempl", true);
define("xmlgm_checkpointtablerowtempl_default", "", true);
define("key_xmlgm_gpxmarkertempl", "xmlgm_gpxmarkertempl", true);
define("xmlgm_gpxmarkertempl_default", "", true);
define("key_xmlgm_nggmarkertempl", "xmlgm_nggmarkertempl", true);
define("xmlgm_nggmarkertempl_default", "", true);


add_option(key_xmlgm_dragging, xmlgm_dragging_default, 'Enables/Disables Dragging on Google Map');
add_option(key_xmlgm_doubleClickZoom, xmlgm_doubleClickZoom_default, 'Enables/Disables Double Click Zoom on Google Map');
add_option(key_xmlgm_continuousZoom, xmlgm_continuousZoom_default, 'Enables/Disables Continuous Zoom on Google Map');
add_option(key_xmlgm_googleBar, xmlgm_googleBar_default, 'Enables/Disables Google Bar on Google Map');
add_option(key_xmlgm_scrollWheelZoom, xmlgm_scrollWheelZoom_default, 'Enables/Disables Scroll Wheel Zoom on Google Map');
add_option(key_xmlgm_uid, xmlgm_uid_default, 'Your Google Maps API Key');
add_option(key_xmlgm_width, xmlgm_width_default, 'Width of your Google Map');
add_option(key_xmlgm_height, xmlgm_height_default, 'Height of your Google Map');
add_option(key_xmlgm_align, xmlgm_align_default, 'Align of your Google Map');
add_option(key_xmlgm_linecolor, xmlgm_linecolor_default, 'Default Line Color of Tracks and Routes');
add_option(key_xmlgm_urldisplaymode, xmlgm_urldisplaymode_default, 'Default display mode for URL');
add_option(key_xmlgm_viewstyle, xmlgm_viewstyle_default, 'Default style for MAP');
add_option(key_xmlgm_linewidth, xmlgm_linewidth_default, 'Default Line Width of Tracks and Routes');
add_option(key_xmlgm_lineopacity, xmlgm_lineopacity_default, 'Default Line Opacity of Tracks and Routes');
add_option(key_xmlgm_gpxview, xmlgm_gpxview_default, 'Default GPX View Mode');
add_option(key_xmlgm_panzoomcontrol, xmlgm_panzoomcontrol_default, 'Pan/Zoom Control');
add_option(key_xmlgm_overviewmap, xmlgm_overviewmap_default, 'Overview Map Control');
add_option(key_xmlgm_scalecontrol, xmlgm_scalecontrol_default, 'Scale Control');
add_option(key_xmlgm_maptypecontrol, xmlgm_maptypecontrol_default, 'Map Type Control');
add_option(key_xmlgm_elevlinecolor, xmlgm_elevlinecolor_default, 'Elevation Chart Line Color');
add_option(key_xmlgm_elevationchart, xmlgm_elevationchart_default, 'Visibility of Elevation Chart');
add_option(key_xmlgm_elelinewidth, xmlgm_elelinewidth_default, 'Elevation Chart Line Width');
add_option(key_xmlgm_elevationheight, xmlgm_elevationheight_default, 'Height of Elevation Chart');
add_option(key_xmlgm_elevationmeasurement, xmlgm_elevationmeasurement_default, 'Measurement type everything');
add_option(key_xmlgm_gpxcssstyle, xmlgm_gpxcssstyle_default, 'GPX Waypoint CSS Style of Title and Description');
add_option(key_xmlgm_mapnorm, xmlgm_mapnorm_default, 'Shows/Hides Normal Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapsat, xmlgm_mapsat_default, 'Shows/Hides Satellite Map Button if Map Type Control is shown');
add_option(key_xmlgm_maphyb, xmlgm_maphyb_default, 'Shows/Hides Hybrid Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapphy, xmlgm_mapphy_default, 'Shows/Hides Physical Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapearth, xmlgm_mapearth_default, 'Shows/Hides Google Earth Map Button if Map Type Control is shown');
add_option(key_xmlgm_speedlinecolor, xmlgm_speedlinecolor_default, 'Speed Chart Line Color');
add_option(key_xmlgm_speedchart, xmlgm_speedchart_default, 'Visibility of Speed Chart');
add_option(key_xmlgm_speedlinewidth, xmlgm_speedlinewidth_default, 'Speed Chart Line Width');
add_option(key_xmlgm_speedheight, xmlgm_speedheight_default, 'Height of Speed Chart');
add_option(key_xmlgm_speedscale, xmlgm_speedscale_default, 'Speed Scale');
add_option(key_xmlgm_elevationtitle, xmlgm_elevationtitle_default, 'Title of Elevation Chart');
add_option(key_xmlgm_speedcharttitle, xmlgm_speedcharttitle_default, 'Title of Speed Chart');
add_option(key_xmlgm_checkpointmapmarkercolor, xmlgm_checkpointmapmarkercolor_default, 'Checkpoint Marker Color on map');
add_option(key_xmlgm_checkpointtable, xmlgm_checkpointtable_default, 'Shows/Hides a checkpoint table');
add_option(key_xmlgm_checkpointinterval, xmlgm_checkpointinterval_default, 'Defines the default Checkpoint Interval (0=hide)');
add_option(key_xmlgm_checkpointtablerowtempl, xmlgm_checkpointtablerowtempl_default, 'HTML Template for the Checkpoint Table Row');
add_option(key_xmlgm_checkpointtabletempl, xmlgm_checkpointtabletempl_default, 'HTML Template for the Checkpoint Table');
add_option(key_xmlgm_kmlparsing, xmlgm_kmlparsing_default, 'Enables/Disables KML parsing for correct view!');
add_option(key_xmlgm_gpxmarkertempl, xmlgm_gpxmarkertempl_default, 'HTML Template for the GPX Marker');
add_option(key_xmlgm_nggmarkertempl, xmlgm_nggmarkertempl_default, 'HTML Template for the NextGen Gallery Marker');
add_option(key_xmlgm_gpxdirectopenwplink, xmlgm_gpxdirectopenwplink_default, 'If this option is set to click or doubleclick, this effect on marker will open the link in the GPX Waypoint Element!');


//Actions & Filters
add_filter('the_content', 'xmlgooglemaps_converter', 2);
add_filter('upload_mimes', 'xmlgooglemaps_mimes');
add_action('admin_menu', 'add_xmlgm_option_page');

//Add Option Page
function add_xmlgm_option_page() {
	global $wpdb;
	add_options_page('XML Google Maps Options', 'XML Google Maps', 8, basename(__FILE__), 'xmlgm_options_page');
}

function xmlgooglemaps_converter($content) {
	global $wpdb;

	require_once(dirname(__FILE__).'/xmlgooglemaps_helper.php');

	dbinstall();

	$content = str_replace("\n","####nnnn####", $content);
	$content = str_replace("\r","####rrrr####", $content);

	//GPX
	$content = xmlgooglemaps_converter_gpx($content);

	//KMX
	$content = xmlgooglemaps_converter_kmx($content);

	// Google Maps Meine Karten: http://maps.google.com/maps/ms?ie=UTF8&hl=de&msa=0&output=nl&msid=102758581694521177745.00000111d56d20b14f816
	$content = xmlgooglemaps_converter_GoogleMaps($content);

	// Picasa Maps
	$content = xmlgooglemaps_converter_Picasa($content);

	//XML Google Maps Parts
	$content = xmlgooglemaps_converter_myxmlgm($content);

	$content = str_replace("####nnnn####","\n", $content);
	$content = str_replace("####rrrr####","\r", $content);

	return $content;
}

function xmlgooglemaps_mimes($mimes) {
	$mime_types = array ('gpx' => 'application/gpx', 'kml' => 'application/vnd.google-earth.kml+xml', 'kmz' => 'application/vnd.google-earth.kmz+xml');
	return array_merge($mimes,$mime_types);
}

function dbinstall() {
	global $wpdb;
	if (!gmxml_tableexists($wpdb->xmlgooglemapsdb)) {
		$create_sql = "CREATE TABLE $wpdb->xmlgooglemapsdb (".
				"xml_id INT(11) NOT NULL auto_increment,".
				"xml_path TEXT NOT NULL ,".
				"xml_path_resolved TEXT NOT NULL ,".
				"PRIMARY KEY (xml_id))";
		$wpdb->query($create_sql);
	}
	if (!gmxml_columnexists($wpdb->xmlgooglemapsdb,"xml_varstring")) {
		$column_sql = "ALTER TABLE $wpdb->xmlgooglemapsdb ADD COLUMN xml_varstring TEXT NOT NULL;";
		$wpdb->query($column_sql);
	}
}

function xmlgooglemaps_converter_Picasa($content) {

	preg_match_all('#\<a([^\>]*?)href=["\'](http:\/\/picasaweb\.google\.[a-z\.]*\/data\/feed\/base\/user\/[a-zA-Z0-9\/:\-\.,_?&=;~]*?)["\']([^\>]*?)\>(.*?)\<\/a\>#i', $content, $found);

	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		$file = str_replace("&amp;","&",$file);
		$file_resolved = $file;

		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];

		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}

		$params = new xml_gm_params();
		$params->setParams($varstring);

		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);

		if (strtolower($params->urlDisplayMode) == "nomap") {
			$content = str_replace($found[0][$i],$displayurl,$content);
		} else {
			$mygooglemapid = getid($file, $file_resolved, $varstring);
			$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?mygooglemapid='.$mygooglemapid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_My_Map" frameborder="0"></iframe></div>'.$displayurl,$content);
		}
	}
	return $content;
}

function xmlgooglemaps_converter_GoogleMaps($content) {

	preg_match_all('#\<a([^\>]*?)href=["\'](http:\/\/maps\.google\.[a-z\.]*\/maps\/ms[a-zA-Z0-9\/:\-\.,_?&=;~]*?)["\']([^\>]*?)\>(.*?)\<\/a\>#i', $content, $found);

	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		$file = str_replace("&amp;","&",$file);

		if (stripos(strtolower($file),"msid=") !== false) {
				
			if (stripos(strtolower($file),"output=") === false) {
				$file .= "&output=nl";
			}

			$file_resolved = $file;
				
			$displayurl = $found[0][$i];
			$urlstring = $found[4][$i];
				
			$iurlstring = stripos($urlstring,"[");
			if ($iurlstring !== false) {
				$jurlstring = stripos($urlstring,"]",$iurlstring);
				$iurlstring += 1;
				$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
			} else {
				$varstring = "";
			}
				
			$params = new xml_gm_params();
			$params->setParams($varstring);
			$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);
			if (strtolower($params->urlDisplayMode) == "nomap") {
				$content = str_replace($found[0][$i],$displayurl,$content);
			} else {
				$mygooglemapid = getid($file, $file_resolved, $varstring);
				$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?mygooglemapid='.$mygooglemapid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_My_Map" frameborder="0"></iframe></div>'.$displayurl,$content);
			}
		} else {
			$content = str_replace($found[0][$i],'<p style="color: red;"><b>Error in displaying map:</b><br />I think your link to the My Google Maps is not correct. Please have a look at the following image:<br /><img alt="Help" src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/help01.jpg" /><br />You have to save your Google Map first!</p>'.$displayurl,$content);
		}
	}
	return $content;
}

function xmlgooglemaps_converter_kmx($content) {
	preg_match_all('#\<a([^\>]*?)href=["\']([a-zA-Z0-9\/:\-\._?&=;~]*?\.km[lz])["\']([^\>]*?)\>(.*?)\<\/a\>#i', $content, $found);
		
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];

		$plugins=get_option('active_plugins');
		$pluginpath= "";
		for ($j=0; $j<count($plugins); $j++) {
			if (stripos($plugins[$j],"xmlgooglemaps.php") > 0) {
				$pluginpath = dirname(PLUGINDIR."/".$plugins[$j]);
				break;
			}
		}
		$surl = get_option('siteurl');
		$spath = preg_replace('|/'.$pluginpath.'.*|i', '', dirname(__FILE__));

		$file_resolved = $file;

		if (stripos($file,$surl)==0) {
			$newres = str_replace($surl,$spath,$file);
			if (file_exists($newres)) {
				$file_resolved = $newres;
			}
		}

		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}

		$params = new xml_gm_params();
		$params->setParams($varstring);
		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);
		if (strtolower($params->urlDisplayMode) == "nomap") {
			$content = str_replace($found[0][$i],$displayurl,$content);
		} else {
			$kmlid = getid($file, $file_resolved, $varstring);
			$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?kmlid='.$kmlid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_KML_Maps" frameborder="0"></iframe></div>'.$displayurl,$content);
		}
	}
	return $content;
}

function xmlgooglemaps_converter_myxmlgm($content) {
	preg_match_all('#\[xmlgm([^\]]*?)\]#i', $content, $found);
	for ($i=0; $i< count($found[0]);$i++) {
		$varstring = str_replace("[xmlgm","", $found[0][$i]);
		$varstring = str_replace("]","", $varstring);
		$varstring = trim($varstring);

		//Support added for any other GeoXML [xmlgm {url} parameter]
		$pathi = stripos($varstring,"{");
		$pathj = stripos($varstring,"}");

		if (($pathi !== false) && ($pathj !== false)) {
			$path = trim(substr($varstring,$pathi+1,$pathj-$pathi-1));
			$varstring = trim(substr($varstring,0,$pathi).substr($varstring,$pathj+1));
		}

		$params = new xml_gm_params();
		$params->setParams($varstring);

		if (strtolower($params->urlDisplayMode) != "nomap") {
			$myid = getid($path, $path, $varstring);
				
			$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?myid='.$myid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="My_XML_Google_Maps" frameborder="0"></iframe></div>',$content);
		}
	}

	return $content;
}

function xmlgooglemaps_converter_gpx($content) {
	preg_match_all('#\<a([^\>]*?)href=["\']([a-zA-Z0-9\/:\-\._?&=;~]*?\.gpx)["\']([^\>]*?)\>(.*?)\<\/a\>#i', $content, $found);
	//preg_match_all('/\<a([^\>]*?)href=["\']([a-zA-Z0-9\/:\-\._]*?.gpx)["\']([^\>]*?)\>(.*?)\<\/a\>/i', $content, $found);
	//	print("<!-- ");
	//	print_r($found);
	//	print(" -->");
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];

		$plugins=get_option('active_plugins');
		$pluginpath= "";
		for ($j=0; $j<count($plugins); $j++) {
			if (stripos($plugins[$j],"xmlgooglemaps.php") > 0) {
				$pluginpath = dirname(PLUGINDIR."/".$plugins[$j]);
				break;
			}
		}
		$surl = get_option('siteurl');
		$spath = preg_replace('|/'.$pluginpath.'.*|i', '', dirname(__FILE__));

		$file_resolved = $file;
		if (stripos($file,$surl)==0) {
			$newres = str_replace($surl,$spath,$file);
			if (file_exists($newres)) {
				$file_resolved = $newres;
			}
		}

		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		$displayurl = $found[0][$i];
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}

		$params = new xml_gm_params();
		$params->setParams($varstring);
		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);
		if (strtolower($params->urlDisplayMode) == "nomap") {
			$content = str_replace($found[0][$i],$displayurl,$content);
		} else {
			$gpxid = getid($file, $file_resolved, $varstring);
				
			//Altitudes / Speed Charts
			$altstring = "";
			$speedstring = "";
			$cptabstring = "";
			if (($params->gpxElevationChart == "show") || ($params->gpxSpeedChart == "show") || ($params->gpxCheckpointTable == "show") ) {
				require_once(dirname(__FILE__).'/xmlgooglemaps_gpxParser.php');
				require_once(dirname(__FILE__).'/xmlgooglemaps_googleChartsAPI.php');
				$gpxfile = new gpxParser();
				$gpxfile->parse($file_resolved);
				$gpxdata = $gpxfile->output;
				if (($params->gpxView == "all") || ($params->gpxView == "trk")) {
					$trkmax = $gpxdata["trk_count"];
					$x_ele = array();
					$y_ele = array();
					$dist_speed = array();
					$time_speed = array();
					$ptcount = 0;
					$dist = 0;
					for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
						$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];
						for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount++) {
							$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
							if ($ptcount==0) {
								$lat1 = floatval($pt["lat"]);
								$lon1 = floatval($pt["lon"]);
								$time1 = myFunctions::xmlDate2DateTime($pt["time"]);
							}
							$lat2 = floatval($pt["lat"]);
							$lon2 = floatval($pt["lon"]);
							$time2 = myFunctions::xmlDate2DateTime($pt["time"]);
							$tmp = myFunctions::distBetween2PointsKM($lat1,$lon1,$lat2,$lon2);
							if (!is_nan($tmp)) {
								$dist += $tmp;
								if (($tmp>0) && ($time2-$time1>0)) {
									$dist_speed[] = $tmp;
									$time_speed[] = $time2-$time1;
								}
								switch ($params->measurement) {
									case "imperial":
										$x_ele[] = $dist/1.609344;
										$y_ele[] = $pt["ele"]/0.3048;										
										break;
									case "nautic_imperial":
										$x_ele[] = $dist/1.852216;
										$y_ele[] = $pt["ele"]/0.3048;										
										break;
									case "nautic_metric":
										$x_ele[] = $dist/1.852216;
										$y_ele[] = $pt["ele"];										
										break;
									case "metric":
									default:
										$x_ele[] = $dist;
										$y_ele[] = $pt["ele"];										
										break;
								}
								$lat1 = $lat2;
								$lon1 = $lon2;
								$time1 = $time2;
							}
							$ptcount++;
						}
					}
					if ($dist>0) {
						if ($params->gpxElevationChart == "show") {
							$alt = new googleChartsApi_PMPro($x_ele,$y_ele);
							$altstring .= '<img alt="'.$params->gpxElevationChartTitle.'" style="text-align: '.$params->align.'; margin: 0px; padding: 0px; max-width: 100%;" src="'.$alt->getEleUrl($params->width, $params->gpxElevationChartHeight,$params->gpxElevationLineColor,$params->gpxElevationLineWidth, $params->measurement, $params->gpxElevationChartTitle, $params->gpxCheckpointInterval).'" /><br />';
						}
						if ($params->gpxSpeedChart == "show") {
							$newdist=0;
							$newtime=0;
							$newtotaldist=0;
							$x_speed = array();
							$y_speed = array();
							for ($spi=0;$spi<count($dist_speed); $spi++) {
								$newdist += $dist_speed[$spi];
								$newtotaldist += $dist_speed[$spi];
								$newtime += $time_speed[$spi];
								switch (strtolower($params->measurement.$params->speedscale)) {
									case "imperiallevel2":
										$x_speed[] = $newtotaldist/1.609344;
										$y_speed[] = ($newdist/1.609344) / ($newtime/3600);
										break;
									case "imperiallevel1":
										$x_speed[] = $newtotaldist/1.609344;
										$y_speed[] = ($newdist/0.3048) / ($newtime);
										break;
									case "metriclevel1":
										$x_speed[] = $newtotaldist;
										$y_speed[] = ($newdist*1000) / ($newtime);
										break;
									case "nautic_metriclevel1":
									case "nautic_metriclevel2":
									case "nautic_imperiallevel1":
									case "nautic_imperiallevel2":										
										$x_speed[] = $newtotaldist/1.852216;
										$y_speed[] = ($newdist/1.852216) / ($newtime/3600);
										break;
									default:
									case "metriclevel2":
										$x_speed[] = $newtotaldist;
										$y_speed[] = ($newdist) / ($newtime/3600);
										break;
								}
								$newdist=0;
								$newtime=0;
							}
							$sp = new googleChartsApi_PMPro($x_speed, $y_speed, 0);
							$speedstring .= '<img alt="'.$params->gpxSpeedChartTitle.'" style="text-align: '.$params->align.'; margin: 0px; padding: 0px; max-width: 100%;" src="'.$sp->getSpeedUrl($params->width, $params->gpxSpeedChartHeight,$params->gpxSpeedLineColor,$params->gpxSpeedLineWidth, $params->measurement, $params->speedscale, $params->gpxSpeedChartTitle, $params->gpxCheckpointInterval).'" /><br />';
						}
						if ($params->gpxCheckpointTable == "show") {
							$cptabstring = $params->gpxCheckpointTableTemplate;
							$cptabstring = str_replace("%WIDTH%",$params->width,$cptabstring);
							//Vorbereiten des Masssystems
							switch ($params->measurement) {
								case "imperial":
									$divident = 1.609344;
									$measurement = "mi";
									$divident2 = 0.3048;
									$measurement2 = "ft";
									if ($params->speedscale == "level1") {
										$scale = "fps";
									} else {
										$scale = "mph";
									}
									break;
								case "nautic_metric":	
									$divident = 1.852216;
									$measurement = "nm";
									$divident2 = 1;
									$measurement2 = "m";
									$scale = "kn";
									break;
								case "nautic_imperial":	
									$divident = 1.852216;
									$measurement = "nm";
									$divident2 = 0.3048;
									$measurement2 = "ft";
									$scale = "kn";
									break;
								default:
									$divident = 1;
									$measurement = "km";
									$divident2 = 1;
									$measurement2 = "m";
									if ($params->speedscale == "level1") {
										$scale = "m/s";
									} else {
										$scale = "km/s";
									}
									break;
							}
							//Initialisierung
							$trkmax = $gpxdata["trk_count"];
							$nextcheckpointnumber=1;							
							$dist = 0;
							$lastdist=0;
							$totaltime = 0;
							$lasttotaltime=0;
							$movingtime = 0;							
							$lastmovingtime = 0;											
							$lastpt = "";
							$maxpartspeed = 0;
							$maxspeed = 0;
							$partclimbup = 0;
							$climbup = 0;
							$partclimbdown = 0;
							$climbdown = 0;
							$checkpointnumber = 1;
							//Trackpunkte durchgehen
							for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
								$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];
								for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount+=$params->gpxInterval) {
									$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
									if (($params->gpxCheckpointInterval>0)) {
										if (($trkcount > 0) || ($trkptcount>0)) {
											//2. - n-1. Punkt
											$deltatime = myFunctions::xmlDate2DateTime($pt["time"])-myFunctions::xmlDate2DateTime($lastpt["time"]);
											$deltadist = myFunctions::distBetween2PointsKM(floatval($lastpt["lat"]),floatval($lastpt["lon"]),floatval($pt["lat"]),floatval($pt["lon"]));
											//Zeit und Distanz (Durchschnittsgeschwindigkeit)
											$totaltime += $deltatime;
											$dist += $deltadist;
											//Zeit (nur falls eine Distanz zurckgelegt wurde)
											if ($deltadist!=0) {
												$movingtime += $deltatime;
											}
											//Max Speed
											$maxpartspeed = max(myFunctions::getSpeed($params->measurement,$params->speedscale,$deltadist,$deltatime),$maxpartspeed);
											$maxspeed = max($maxpartspeed,$maxspeed);
											//Hhenmeter
											$elediff = (intval($pt["ele"])-intval($lastpt["ele"]))/ $divident2;
											if ($elediff>0) {
												$climbup += $elediff;
												$partclimbup += $elediff;
											} else {
												$climbdown -= $elediff;
												$partclimbdown -= $elediff;
											}
											if ($dist/$divident>$nextcheckpointnumber*$params->gpxCheckpointInterval) {
												$cpadd="";
												$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
												$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);												
												$cptabstringrow = str_replace("%DISTANCE%" , sprintf("%01.3f",$dist/$divident).' '.$measurement, $cptabstringrow);
												$cptabstringrow = str_replace("%PARTDISTANCE%" , sprintf("%01.3f",($dist-$lastdist)/$divident).' '.$measurement, $cptabstringrow);
												$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
												$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
												$cptabstringrow = str_replace("%MOVINGTIME%" , myFunctions::seconds2Text($movingtime), $cptabstringrow);
												$cptabstringrow = str_replace("%PARTMOVINGTIME%" , myFunctions::seconds2Text($movingtime-$lastmovingtime), $cptabstringrow);
												$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
												$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);
												$cptabstringrow = str_replace("%MOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$movingtime), $cptabstringrow);
												$cptabstringrow = str_replace("%PARTMOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$movingtime-$lastmovingtime), $cptabstringrow);												
												$cptabstringrow = str_replace("%MAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxspeed), $cptabstringrow);
												$cptabstringrow = str_replace("%PARTMAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxpartspeed), $cptabstringrow);
												$cptabstringrow = str_replace("%CHECKPOINTNUMBER%" , $checkpointnumber++, $cptabstringrow);
												$cptabstringrow = str_replace("%CLIMBUP%" , round($climbup,0).' '.$measurement2, $cptabstringrow);
												$cptabstringrow = str_replace("%CLIMBDOWN%" , round($climbdown,0).' '.$measurement2, $cptabstringrow);
												$cptabstringrow = str_replace("%PARTCLIMBUP%" , round($partclimbup,0).' '.$measurement2, $cptabstringrow);
												$cptabstringrow = str_replace("%PARTCLIMBDOWN%" , round($partclimbdown,0).' '.$measurement2, $cptabstringrow);
												$cptabstringrow = str_replace("%LATITUDE%" , myFunctions::latitude2Text($pt["lat"]), $cptabstringrow);
												$cptabstringrow = str_replace("%LONGITUDE%" , myFunctions::longitude2Text($pt["lon"]), $cptabstringrow);
												$cptabstringrow = str_replace("%ELEVATION%" , myFunctions::elevation2Text($pt["ele"],$params->measurement), $cptabstringrow);
												$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);
												$nextcheckpointnumber = floor(($dist/$divident) / $params->gpxCheckpointInterval) + 1;
												$lastdist = $dist;
												$lasttotaltime = $totaltime;
												$lastmovingtime = $movingtime;
												$maxpartspeed = 0;
												$partclimbdown = 0;
												$partclimbup = 0;
											}
										} else {
											//1. Punkt
											$cpadd="_s";
											$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
											$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);
											$cptabstringrow = str_replace("%DISTANCE%" , sprintf("%01.3f",$dist/$divident).' '.$measurement, $cptabstringrow);
											$cptabstringrow = str_replace("%PARTDISTANCE%" , sprintf("%01.3f",($dist-$lastdist)/$divident).' '.$measurement, $cptabstringrow);
											$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%MOVINGTIME%" , myFunctions::seconds2Text($movingtime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTMOVINGTIME%" , myFunctions::seconds2Text($movingtime-$lastmovingtime), $cptabstringrow);											
											$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%MOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$movingtime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTMOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$movingtime-$lastmovingtime), $cptabstringrow);																							
											$cptabstringrow = str_replace("%MAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxspeed), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTMAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxpartspeed), $cptabstringrow);
											$cptabstringrow = str_replace("%CHECKPOINTNUMBER%" , $checkpointnumber++, $cptabstringrow);
											$cptabstringrow = str_replace("%CLIMBUP%" , '-', $cptabstringrow);
											$cptabstringrow = str_replace("%CLIMBDOWN%" , '-', $cptabstringrow);
											$cptabstringrow = str_replace("%PARTCLIMBUP%" , '-', $cptabstringrow);
											$cptabstringrow = str_replace("%PARTCLIMBDOWN%" , '-', $cptabstringrow);
											$cptabstringrow = str_replace("%LATITUDE%" , myFunctions::latitude2Text($pt["lat"]), $cptabstringrow);
											$cptabstringrow = str_replace("%LONGITUDE%" , myFunctions::longitude2Text($pt["lon"]), $cptabstringrow);
											$cptabstringrow = str_replace("%ELEVATION%" , myFunctions::elevation2Text($pt["ele"],$params->measurement), $cptabstringrow);											
											$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);
										}
									}
									$lastpt = $pt;
								}
							}
							if (($params->gpxCheckpointInterval>0)) {
								//Letzter Punkt, falls noch notwendig!
								$cpadd="_e";
								$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
								$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);
								$cptabstringrow = str_replace("%DISTANCE%" , sprintf("%01.3f",$dist/$divident).' '.$measurement, $cptabstringrow);
								$cptabstringrow = str_replace("%PARTDISTANCE%" , sprintf("%01.3f",($dist-$lastdist)/$divident).' '.$measurement, $cptabstringrow);
								$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
								$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
								$cptabstringrow = str_replace("%MOVINGTIME%" , myFunctions::seconds2Text($movingtime), $cptabstringrow);
								$cptabstringrow = str_replace("%PARTMOVINGTIME%" , myFunctions::seconds2Text($movingtime-$lastmovingtime), $cptabstringrow);																
								$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
								$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);
								$cptabstringrow = str_replace("%MOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$movingtime), $cptabstringrow);
								$cptabstringrow = str_replace("%PARTMOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$movingtime-$lastmovingtime), $cptabstringrow);								
								$cptabstringrow = str_replace("%MAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxspeed), $cptabstringrow);
								$cptabstringrow = str_replace("%PARTMAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxpartspeed), $cptabstringrow);
								$cptabstringrow = str_replace("%CHECKPOINTNUMBER%" , $checkpointnumber++, $cptabstringrow);
								$cptabstringrow = str_replace("%CLIMBUP%" , round($climbup,0).' '.$measurement2, $cptabstringrow);
								$cptabstringrow = str_replace("%CLIMBDOWN%" , round($climbdown,0).' '.$measurement2, $cptabstringrow);
								$cptabstringrow = str_replace("%PARTCLIMBUP%" , round($partclimbup,0).' '.$measurement2, $cptabstringrow);
								$cptabstringrow = str_replace("%PARTCLIMBDOWN%" , round($partclimbdown,0).' '.$measurement2, $cptabstringrow);
								$cptabstringrow = str_replace("%LATITUDE%" , myFunctions::latitude2Text($pt["lat"]), $cptabstringrow);
								$cptabstringrow = str_replace("%LONGITUDE%" , myFunctions::longitude2Text($pt["lon"]), $cptabstringrow);
								$cptabstringrow = str_replace("%ELEVATION%" , myFunctions::elevation2Text($pt["ele"],$params->measurement), $cptabstringrow);								
								$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);
							}
							//Endbehandlung
							$cptabstring = str_replace("%DISTANCE%" , sprintf("%01.3f",$dist/$divident).' '.$measurement, $cptabstring);
							$cptabstring = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstring);
							$cptabstring = str_replace("%MOVINGTIME%" , myFunctions::seconds2Text($movingtime), $cptabstring);
							$cptabstring = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstring);
							$cptabstring = str_replace("%MOVINGSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$movingtime), $cptabstring);
							$cptabstring = str_replace("%MAXSPEED%" , myFunctions::getSpeedString2($params->measurement,$params->speedscale,$maxspeed), $cptabstring);							
							$cptabstring = str_replace("%CLIMBUP%" , round($climbup,0).' '.$measurement2, $cptabstring);
							$cptabstring = str_replace("%CLIMBDOWN%" , round($climbdown,0).' '.$measurement2, $cptabstring);
							$cptabstring = str_replace("%PARTCLIMBUP%" , round($partclimbup,0).' '.$measurement2, $cptabstring);
							$cptabstring = str_replace("%PARTCLIMBDOWN%" , round($partclimbdown,0).' '.$measurement2, $cptabstring);
							$cptabstring = $cptabstring = str_replace("%ROW%","",$cptabstring);;
						}
					}
				}
			}
			$repstring = '<div style="text-align: '.$params->align.';">';
			$repstring .= '<iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?gpxid='.$gpxid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_Gpx_Maps" frameborder="0">';
			$repstring .= '</iframe></div>'.$altstring.$speedstring.$cptabstring.$displayurl.'';
			$content = str_replace($found[0][$i],$repstring,$content);
		}
	}
	return $content;
}

function gmxml_tableexists($tablename) {
	global $wpdb;
	foreach ($wpdb->get_col("SHOW TABLES",0) as $table ) {
		if ($table == $tablename) {
			return true;
		}
	}
	return false;
}

function gmxml_columnexists($tablename, $columnname) {
	global $wpdb;
	foreach ($wpdb->get_col("DESC $tablename", 0) as $column ) {
		if ($column == $columnname) {
			return true;
		}
	}
	return false;
}

function getid($path, $resolvedpath, $varstring) {
	global $wpdb;
	// Check IP From IP Logging Database
	$ret = $wpdb->get_var("SELECT xml_id FROM $wpdb->xmlgooglemapsdb WHERE xml_path = '$path' AND xml_path_resolved = '$resolvedpath' AND xml_varstring = '$varstring'");
	if ($ret == 0) {
		$wpdb->query("INSERT INTO $wpdb->xmlgooglemapsdb (xml_path, xml_path_resolved, xml_varstring) VALUES ('$path','$resolvedpath','$varstring')");
		$ret = getid($path, $resolvedpath, $varstring);
	}
	return intval($ret);
}


//Optiona Page
function xmlgm_options_page() {
	global $wpdb;
	require_once(dirname(__FILE__).'/xmlgooglemaps_helper.php');
	// If we are a postback, store the options
	if (isset($_POST['info_update']) && wp_verify_nonce($_POST['xmlgm-nonce-key'], 'xml-google-maps')) {
		// Google Maps API
		$xmlgm_uid = $_POST[key_xmlgm_uid];
		if ($xmlgm_uid == '')
		$xmlgm_uid = xmlgm_uid_default;
		update_option(key_xmlgm_uid, $xmlgm_uid);

		//Width
		$xmlgm_width = intval($_POST[key_xmlgm_width]);
		if ($xmlgm_width == 0)
		$xmlgm_width = xmlgm_width_default;
		update_option(key_xmlgm_width, $xmlgm_width);

		//Height
		$xmlgm_height = intval($_POST[key_xmlgm_height]);
		if ($xmlgm_height == 0)
		$xmlgm_height = xmlgm_height_default;
		update_option(key_xmlgm_height, $xmlgm_height);

		// IFrame Align
		$xmlgm_align = $_POST[key_xmlgm_align];
		if ($xmlgm_align == '')
		$xmlgm_align = xmlgm_align_default;
		update_option(key_xmlgm_align, $xmlgm_align);

		// Line Color
		$xmlgm_linecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_linecolor]);
		if ($xmlgm_linecolor == '')
		$xmlgm_linecolor = xmlgm_linecolor_default;
		update_option(key_xmlgm_linecolor, $xmlgm_linecolor);

		// Elevation Line Color
		$xmlgm_elelinecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_elevlinecolor]);
		if ($xmlgm_elelinecolor == '')
		$xmlgm_elelinecolor = xmlgm_elevlinecolor_default;
		update_option(key_xmlgm_elevlinecolor, $xmlgm_elelinecolor);

		// Elevation Chart Visibility
		$xmlgm_elevationchart = $_POST[key_xmlgm_elevationchart];
		if ($xmlgm_elevationchart == '')
		$xmlgm_elevationchart = xmlgm_elevationchart_default;
		update_option(key_xmlgm_elevationchart, $xmlgm_elevationchart);

		//Elevation Line Width
		$xmlgm_elelinewidth = intval($_POST[key_xmlgm_elelinewidth]);
		if ($xmlgm_elelinewidth == 0)
		$xmlgm_elelinewidth = xmlgm_elelinewidth_default;
		update_option(key_xmlgm_elelinewidth, $xmlgm_elelinewidth);

		// Speed Line Color
		$xmlgm_speedlinecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_speedlinecolor]);
		if ($xmlgm_speedlinecolor == '')
		$xmlgm_speedlinecolor = xmlgm_speedlinecolor_default;
		update_option(key_xmlgm_speedlinecolor, $xmlgm_speedlinecolor);

		// Speed Chart Visibility
		$xmlgm_speedchart = $_POST[key_xmlgm_speedchart];
		if ($xmlgm_speedchart == '')
		$xmlgm_speedchart = xmlgm_speedchart_default;
		update_option(key_xmlgm_speedchart, $xmlgm_speedchart);

		//Speed Line Width
		$xmlgm_speedlinewidth = intval($_POST[key_xmlgm_speedlinewidth]);
		if ($xmlgm_speedlinewidth == 0)
		$xmlgm_speedlinewidth = xmlgm_speedlinewidth_default;
		update_option(key_xmlgm_speedlinewidth, $xmlgm_speedlinewidth);

		// URL Display Mode
		$xmlgm_urldisplaymode = $_POST[key_xmlgm_urldisplaymode];
		if ($xmlgm_urldisplaymode == '')
		$xmlgm_urldisplaymode = xmlgm_urldisplaymode_default;
		update_option(key_xmlgm_urldisplaymode, $xmlgm_urldisplaymode);

		//Map View Style
		$xmlgm_viewstyle = $_POST[key_xmlgm_viewstyle];
		if ($xmlgm_viewstyle == '')
		$xmlgm_viewstyle = xmlgm_viewstyle_default;
		update_option(key_xmlgm_viewstyle, $xmlgm_viewstyle);

		//Line Width
		$xmlgm_linewidth = intval($_POST[key_xmlgm_linewidth]);
		if ($xmlgm_linewidth == 0)
		$xmlgm_linewidth = xmlgm_linewidth_default;
		update_option(key_xmlgm_linewidth, $xmlgm_linewidth);

		//Elevation Height
		$xmlgm_eleheight = intval($_POST[key_xmlgm_elevationheight]);
		if ($xmlgm_eleheight == 0)
		$xmlgm_eleheight = xmlgm_elevationheight_default;
		update_option(key_xmlgm_elevationheight, $xmlgm_eleheight);

		//Elevation Height
		$xmlgm_speedheight = intval($_POST[key_xmlgm_speedheight]);
		if ($xmlgm_speedheight == 0)
		$xmlgm_speedheight = xmlgm_speedheight_default;
		update_option(key_xmlgm_speedheight, $xmlgm_speedheight);

		//Line Opacity
		$xmlgm_lineopacity = intval($_POST[key_xmlgm_lineopacity]);
		if (($xmlgm_lineopacity < 0) || ($xmlgm_lineopacity > 100))
		$xmlgm_lineopacity = xmlgm_lineopacity_default;
		update_option(key_xmlgm_lineopacity, $xmlgm_lineopacity);

		//GPX View Style
		$xmlgm_gpxview = $_POST[key_xmlgm_gpxview];
		if ($xmlgm_gpxview == '')
		$xmlgm_gpxview = xmlgm_gpxview_default;
		update_option(key_xmlgm_gpxview, $xmlgm_gpxview);

		//Pan/Zoom Control
		$xmlgm_panzoomcontrol = $_POST[key_xmlgm_panzoomcontrol];
		if ($xmlgm_panzoomcontrol == '')
		$xmlgm_panzoomcontrol = xmlgm_panzoomcontrol_default;
		update_option(key_xmlgm_panzoomcontrol, $xmlgm_panzoomcontrol);

		//Overview Map Control
		$xmlgm_overviewmap = $_POST[key_xmlgm_overviewmap];
		if ($xmlgm_overviewmap == '')
		$xmlgm_overviewmap = xmlgm_overviewmap_default;
		update_option(key_xmlgm_overviewmap, $xmlgm_overviewmap);

		//Scale Control
		$xmlgm_scalecontrol = $_POST[key_xmlgm_scalecontrol];
		if ($xmlgm_scalecontrol == '')
		$xmlgm_scalecontrol = xmlgm_scalecontrol_default;
		update_option(key_xmlgm_scalecontrol, $xmlgm_scalecontrol);

		//Map Type Control
		$xmlgm_maptypecontrol = $_POST[key_xmlgm_maptypecontrol];
		if ($xmlgm_maptypecontrol == '')
		$xmlgm_maptypecontrol = xmlgm_maptypecontrol_default;
		update_option(key_xmlgm_maptypecontrol, $xmlgm_maptypecontrol);

		//Measurement Type
		$xmlgm_elevationmeasurement = $_POST[key_xmlgm_elevationmeasurement];
		if ($xmlgm_elevationmeasurement == '')
		$xmlgm_elevationmeasurement = xmlgm_elevationmeasurement_default;
		update_option(key_xmlgm_elevationmeasurement, $xmlgm_elevationmeasurement);

		//Speed Scale
		$xmlgm_speedscale = $_POST[key_xmlgm_speedscale];
		if ($xmlgm_speedscale == '')
		$xmlgm_speedscale = xmlgm_speedscale_default;
		update_option(key_xmlgm_speedscale, $xmlgm_speedscale);

		//GPX Waypoint CSS Style
		$xmlgm_gpxcssstyle = $_POST[key_xmlgm_gpxcssstyle];
		if ($xmlgm_gpxcssstyle == '')
		$xmlgm_gpxcssstyle = xmlgm_gpxcssstyle_default;
		update_option(key_xmlgm_gpxcssstyle, $xmlgm_gpxcssstyle);

		//GPX Direct Open Waypoint Link
		$xmlgm_gpxdirectopenwplink = $_POST[key_xmlgm_gpxdirectopenwplink];
		if ($xmlgm_gpxdirectopenwplink == '')
		$xmlgm_gpxdirectopenwplink = xmlgm_gpxdirectopenwplink_default;
		update_option(key_xmlgm_gpxdirectopenwplink, $xmlgm_gpxdirectopenwplink);
		
		//Map Button Normal
		$xmlgm_mapnorm = $_POST[key_xmlgm_mapnorm];
		if ($xmlgm_mapnorm == '')
		$xmlgm_mapnorm = xmlgm_mapnorm_default;
		update_option(key_xmlgm_mapnorm, $xmlgm_mapnorm);

		//Map Satellite Normal
		$xmlgm_mapsat = $_POST[key_xmlgm_mapsat];
		if ($xmlgm_mapsat == '')
		$xmlgm_mapsat = xmlgm_mapsat_default;
		update_option(key_xmlgm_mapsat, $xmlgm_mapsat);

		//Map Hybrid Normal
		$xmlgm_maphyb = $_POST[key_xmlgm_maphyb];
		if ($xmlgm_maphyb == '')
		$xmlgm_maphyb = xmlgm_maphyb_default;
		update_option(key_xmlgm_maphyb, $xmlgm_maphyb);

		//Map Physical Normal
		$xmlgm_mapphy = $_POST[key_xmlgm_mapphy];
		if ($xmlgm_mapphy == '')
		$xmlgm_mapphy = xmlgm_mapphy_default;
		update_option(key_xmlgm_mapphy, $xmlgm_mapphy);

		//Map Google Earth  Plugin
		$xmlgm_mapearth = $_POST[key_xmlgm_mapearth];
		if ($xmlgm_mapearth == '')
		$xmlgm_mapearth = xmlgm_mapearth_default;
		update_option(key_xmlgm_mapearth, $xmlgm_mapearth);

		//Dragging
		$xmlgm_dragging = $_POST[key_xmlgm_dragging];
		if ($xmlgm_dragging == '')
		$xmlgm_dragging = xmlgm_dragging_default;
		update_option(key_xmlgm_dragging, $xmlgm_dragging);

		//Double Click Zoom
		$xmlgm_doubleclickzoom = $_POST[key_xmlgm_doubleClickZoom];
		if ($xmlgm_doubleclickzoom == '')
		$xmlgm_doubleclickzoom = xmlgm_doubleClickZoom_default;
		update_option(key_xmlgm_doubleClickZoom, $xmlgm_doubleclickzoom);

		//Continuous Zoom
		$xmlgm_continuouszoom = $_POST[key_xmlgm_continuousZoom];
		if ($xmlgm_continuouszoom == '')
		$xmlgm_continuouszoom = xmlgm_continuousZoom_default;
		update_option(key_xmlgm_continuousZoom, $xmlgm_continuouszoom);

		//Google Bar
		$xmlgm_googlebar = $_POST[key_xmlgm_googleBar];
		if ($xmlgm_googlebar == '')
		$xmlgm_googlebar = xmlgm_googleBar_default;
		update_option(key_xmlgm_googleBar, $xmlgm_googlebar);

		//Scroll Wheel Zoom
		$xmlgm_scrollwheelzoom = $_POST[key_xmlgm_scrollWheelZoom];
		if ($xmlgm_scrollwheelzoom == '')
		$xmlgm_scrollwheelzoom = xmlgm_scrollWheelZoom_default;
		update_option(key_xmlgm_scrollWheelZoom, $xmlgm_scrollwheelzoom);

		//Elevation Chart Title
		update_option(key_xmlgm_elevationtitle, $_POST[key_xmlgm_elevationtitle]);

		//Speed Chart Title
		update_option(key_xmlgm_speedcharttitle, $_POST[key_xmlgm_speedcharttitle]);

		//Checkpoint Marker Color
		$xmlgm_cpcol = $_POST[key_xmlgm_checkpointmapmarkercolor];
		if ($xmlgm_cpcol == '')
		$xmlgm_cpcol = xmlgm_checkpointmapmarkercolor_default;
		update_option(key_xmlgm_checkpointmapmarkercolor, $xmlgm_cpcol);

		//Checkpoint Table
		$xmlgm_cptable = $_POST[key_xmlgm_checkpointtable];
		if ($xmlgm_cptable == '')
		$xmlgm_cptable = xmlgm_checkpointtable_default;
		update_option(key_xmlgm_checkpointtable, $xmlgm_cptable);
		
		//Checkpoint Interval
		$xmlgm_cpint = floatval($_POST[key_xmlgm_checkpointinterval]);
		update_option(key_xmlgm_checkpointinterval, $xmlgm_cpint);

		//Checkpoint Table Template
		$xmlgm_cptabletempl = $_POST[key_xmlgm_checkpointtabletempl];
		if ($xmlgm_cptabletempl == '') {
			$filename = dirname(__FILE__)."/defaultcptable.template";
			$handle = fopen ($filename, "r");
			$xmlgm_cptabletempl = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$xmlgm_cptabletempl = str_replace('\"','"',$xmlgm_cptabletempl);
			$xmlgm_cptabletempl = str_replace("\'","'",$xmlgm_cptabletempl);
		}
		update_option(key_xmlgm_checkpointtabletempl, $xmlgm_cptabletempl);

		//Checkpoint Table Row Template
		$xmlgm_cptablerowtempl = $_POST[key_xmlgm_checkpointtablerowtempl];
		if ($xmlgm_cptablerowtempl == '') {
			$filename = dirname(__FILE__)."/defaultcptablerow.template";
			$handle = fopen ($filename, "r");
			$xmlgm_cptablerowtempl = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$xmlgm_cptablerowtempl = str_replace('\"','"',$xmlgm_cptablerowtempl);
			$xmlgm_cptablerowtempl = str_replace("\'","'",$xmlgm_cptablerowtempl);
		}
		update_option(key_xmlgm_checkpointtablerowtempl, $xmlgm_cptablerowtempl);
		
		//GPX Marker Template
		$xmlgm_gpxmartempl = $_POST[key_xmlgm_gpxmarkertempl];
		if ($xmlgm_gpxmartempl == '') {
			$filename = dirname(__FILE__)."/defaultgpxmarker.template";
			$handle = fopen ($filename, "r");
			$xmlgm_gpxmartempl = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$xmlgm_gpxmartempl = str_replace('\"','"',$xmlgm_gpxmartempl);
			$xmlgm_gpxmartempl = str_replace("\'","'",$xmlgm_gpxmartempl);
		}
		update_option(key_xmlgm_gpxmarkertempl, $xmlgm_gpxmartempl);

		//NGG Marker Template
		$xmlgm_nggmartempl = $_POST[key_xmlgm_nggmarkertempl];
		if ($xmlgm_nggmartempl == '') {
			$filename = dirname(__FILE__)."/defaultnggmarker.template";
			$handle = fopen ($filename, "r");
			$xmlgm_nggmartempl = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$xmlgm_nggmartempl = str_replace('\"','"',$xmlgm_nggmartempl);
			$xmlgm_nggmartempl = str_replace("\'","'",$xmlgm_nggmartempl);
		}
		update_option(key_xmlgm_nggmarkertempl, $xmlgm_nggmartempl);		
		
		//KML Parsing
		$xmlgm_kmlparsing = $_POST[key_xmlgm_kmlparsing];
		if ($xmlgm_kmlparsing == '')
			$xmlgm_kmlparsing = xmlgm_kmlparsing_default;
		update_option(key_xmlgm_kmlparsing, $xmlgm_kmlparsing);
		
		
		// Give an updated message
		echo "<div class='updated'><p><strong>XML Google Maps options updated</strong></p></div>";
	} else {
		//Default Werte setzen
		if (strlen(get_option(key_xmlgm_checkpointtabletempl))==0) {
			$filename = dirname(__FILE__)."/defaultcptable.template";
			if (file_exists($filename)) {
				$handle = fopen ($filename, "r");
				$tmp = fread ($handle, filesize ($filename));
				fclose ($handle);
				update_option(key_xmlgm_checkpointtabletempl, $tmp);
			}
		}
		if (strlen(get_option(key_xmlgm_checkpointtablerowtempl))==0) {
			$filename = dirname(__FILE__)."/defaultcptablerow.template";
			if (file_exists($filename)) {
				$handle = fopen ($filename, "r");
				$tmp = fread ($handle, filesize ($filename));
				fclose ($handle);
				update_option(key_xmlgm_checkpointtablerowtempl, $tmp);
			}
		}
		if (strlen(get_option(key_xmlgm_gpxmarkertempl))==0) {
			$filename = dirname(__FILE__)."/defaultgpxmarker.template";
			if (file_exists($filename)) {
				$handle = fopen ($filename, "r");
				$tmp = fread ($handle, filesize ($filename));
				fclose ($handle);
				update_option(key_xmlgm_gpxmarkertempl, $tmp);
			}
		}	
		if (strlen(get_option(key_xmlgm_nggmarkertempl))==0) {
			$filename = dirname(__FILE__)."/defaultnggmarker.template";
			if (file_exists($filename)) {
				$handle = fopen ($filename, "r");
				$tmp = fread ($handle, filesize ($filename));
				fclose ($handle);
				update_option(key_xmlgm_nggmarkertempl, $tmp);
			}
		}				
	}
	$navigation .= '<td  rowspan="100%" width="15%" valign="top">';
	$navigation .= '<div style="text-align: right;"><p><b>Navigation:</b><br /><a href="#basic">Basic Options</a><br /><a href="#control">Control Options</a><br /><a href="#maptype">Map Type Options</a><br /><a href="#mapbehaviour">Map Behaviour Options</a><br /><a href="#gpx">GPX Options</a><br /><a href="#elev">Elevation Chart Options</a><br /><a href="#speedchart">Speed Chart Options</a><br /><a href="#checkpoint">Checkpoint Options</a><br /><a href="#templ">Templates</a></p></div>';
	$navigation .= '<div style="text-align: right;"><input class="button" type="submit" name="info_update" value="Save Changes" /></div>';
	$navigation .= '</td>';
	//TIPPS
	$ngg = new nggFunctions();
	$tipps = array();
	$tipps[] = "What about a <a href='http://www.matusz.ch/donate_xmlgooglemapswpplugin.htm' target='_blank'>donation</a>! I spent a lot of time in developing this plugin. <a href='http://www.matusz.ch/donate_xmlgooglemapswpplugin.htm' target='_blank'>Donate now</a>!";
	$tipps[] = "What about a <a href='http://www.matusz.ch/donate_xmlgooglemapswpplugin.htm' target='_blank'>donation</a>! I spent a lot of time in developing this plugin. <a href='http://www.matusz.ch/donate_xmlgooglemapswpplugin.htm' target='_blank'>Donate now</a>!";	
	if ($ngg->isNggInstalled()) {
		$tipps[] = "This plugin reads the gps position information out of your <b>NextGEN Gallery</b> Plugin images. Use ngg_gallery=&lt;gallerid&gt; to show the whole geotagged Gallery on your map or use ngg_picture=&lt;picture id&gt; to show a single picture!";
		$tipps[] = "Did you know that the <b>NextGEN</b> Parameters can be used more than once to show multiple galleries or pictures? [xmlgml ngg_gallery=1; ngg_gallery=2] will show the first and second gallery images on the map!";
	}
	$tipps[] = "This plugin can handle <b><a href='http://www.umapper.com' target='_blank'>umapper.com</a></b> KML links. Try this [xmlgm {&lt;link to the umapper kml file&gt;}] or &lt;a href=&apos;http://www.umapper.com/download/maps/kml/xxx.kml&apos&gt;Testmap&lt;/a&gt;!";
	$tipps[] = "There are a lot of <b>samples</b> how to use this plugin. Have a look at the <a href='http://www.matusz.ch/blog/projekte/xml-google-maps-wordpress-plugin-en/samples/' target='_blank'>English</a> or <a href='http://www.matusz.ch/blog/projekte/xml-google-maps-wordpress-plugin/beispiele/' target='_blank'>German</a> Sample Page!";
	$tipps[] = "Did you know that a <b>GeoRSS</b> Feed can be converted into a map with this plugin? Try this [xmlgm {&lt;link to the georss feed&gt;}]!";
	$tipps[] = "Try the <b>Google Earth Browser Plugin</b> in the Google Maps API - this rocks! Set the Default Map Type &apos;Google Earth Plugin&apos;!";
	$tipps[] = "Have a look at the Checkpoint Table feature if you're using a GPX file. This feature will extract additional data out of your GPX tracks (Average Speed, Moving Speed, Max Speed, Climbing up, Climbing down, Distances, Moving Time, Time)!";	
	$tipps[] = "This plugin supports metric, imperial and nautical measurement types!";
	$tipps[] = "Did the your KML maps won't show at the correct location or without the right zoomlevel? Try to change the KML Parsing parameter!";
	$tipps[] = "Check the <a href='#templ'>templates</a> options section! Define the look and feel of your GPX or NextGen Gallery markers!";
	$tipps[] = "Did you ever doubleclicked on a GPX Waypoint Marker that has a Link Element? Yes, this plugin will directly open the specified URL in a new window! You want to open the URL by one click or disable this function, no problem: simply set the specific option or parameter to the specific value!";
	if (count($tipps)>0) {
		$tip =	"<table class='form-table' cellspacing='2' cellpadding='5' width='100%'><tr><td width='55px'><img alt='Information' src='".get_option('siteurl')."/wp-content/plugins/xml-google-maps/tipp48.png'></td><td>".$tipps[rand(0,count($tipps)-1)]."</td><td width='55px'><img alt='Information' src='".get_option('siteurl')."/wp-content/plugins/xml-google-maps/tipp48.png'></td></tr></table>";
	}
	// Output the options page
	?>
<script type="text/javascript">
		<!--
			var enabling = function() {
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_NORMAL_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_HYBRID_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_PHYSICAL_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_SATELLITE_3D_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}					
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_elevationmeasurement; ?>.value == "imperial") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Foot per second (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Miles per hour (level2)"
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_elevationmeasurement; ?>.value == "metric") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Metre per second (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Kilometre per hour (level2)"				
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_elevationmeasurement; ?>.value == "nautic_metric") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Knots (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Knots (level2)"				
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_elevationmeasurement; ?>.value == "nautic_imperial") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Knots (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Knots (level2)"				
				}				
				document.forms['xmlgmform'].cpmarker.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + ".png";
				document.forms['xmlgmform'].cpmarker_start.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + "_s.png";
				document.forms['xmlgmform'].cpmarker_end.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + "_e.png";
				//Validation of Checkpoint Table Parameter
				var tmp = parseFloat(document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointinterval; ?>.value);
				if (tmp <= 0 || isNaN(tmp)) {
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.value = "hide";
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.disabled = true;
				} else {
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.disabled = false;
				}
			}
		//-->
		</script>
<form method="post" name="xmlgmform"
	action="options-general.php?page=xmlgooglemaps.php">
	<?php xmlgm_nonce_field(); ?>	
<div class="wrap">

<h2>XML Google Maps Options</h2>	
	<?php echo $tip; ?>
<h3 style="clear: left;"><a name="basic"></a>Basic Options</h3>
<p>First of all you have to get your own Google API Key from the
following page <a href="http://code.google.com/apis/maps/signup.html"
	target="_blank">http://code.google.com/apis/maps/signup.html</a>. Then
specify the width, height and align of the google maps plugin in your
posts.</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_uid; ?>">Your Google Maps API Key:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_uid."' ";
		echo "id='".key_xmlgm_uid."' ";
		echo "value='".get_option(key_xmlgm_uid)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter your Google Maps API Key in this
		box. You get your Google Maps API Key from <a
			href="http://code.google.com/apis/maps/signup.html" target="_blank">http://code.google.com/apis/maps/signup.html</a>.</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_width; ?>">Width:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_width."' ";
		echo "id='".key_xmlgm_width."' ";
		echo "value='".get_option(key_xmlgm_width)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the width of your Map on your posts
		or pages (only numeric value allowed)</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_height; ?>">Height:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_height."' ";
		echo "id='".key_xmlgm_height."' ";
		echo "value='".get_option(key_xmlgm_height)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the height of your Map on your
		posts or pages (only numeric values allowed)</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_align; ?>">Google Map alignement:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_align."' ";
		echo "id='".key_xmlgm_align."'>";
		switch (get_option(key_xmlgm_align))
		{
			case "right": $selright = "selected='selected'"; break;
			case "center": $selcenter = "selected='selected'"; break;
			default: $selleft = "selected='selected'"; break;
		}
		echo "<option value='left' $selleft>Left (left)</option>";
		echo "<option value='center' $selcenter>Center (center)</option>";
		echo "<option value='right' $selright>Right (right)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Specifies the alignement of the map in
		your posts or pages</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_urldisplaymode; ?>">URL Display Mode:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_urldisplaymode."' ";
		echo "id='".key_xmlgm_urldisplaymode."'>";
		switch (get_option(key_xmlgm_urldisplaymode))
		{
			case "none": $selnoneud = "selected='selected'"; break;
			case "showvars": $selvars = "selected='selected'"; break;
			case "nomap": $selnomap = "selected='selected'"; break;
			default: $seldefault = "selected='selected'"; break;
		}
		echo "<option value='title' $seldefault>Map, URL Title without Parameters (title)</option>";
		echo "<option value='none' $selnoneud>Map only (none)</option>";
		echo "<option value='showvars' $selvars>Map, URL Title and Parameters (showvars)</option>";
		echo "<option value='nomap' $selnomap>URL Title without Paramaters and without Map (nomap)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Specifies how to tranform the added Link.
		If you want to completely remove it then select &apos;Map only&apos;.
		If you want to remove only the parameters, then select &apos;Map, URL
		Title without Parameters&apos;. Orelse if you want to show the whole
		link as you typed it in then select &apos;Map, URL Title and
		Parameters&apos;. If you wan't to disable the plugin by default,
		select &apos;URL Title without Paramaters and without Map&apos;!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elevationmeasurement; ?>">Measurement Type:</label>
		</th>
		<td width="50%"><?php
		echo "<select onchange='enabling();' ";
		echo "name='".key_xmlgm_elevationmeasurement."' ";
		echo "id='".key_xmlgm_elevationmeasurement."'>";
		switch (get_option(key_xmlgm_elevationmeasurement))
		{
			case "imperial": $selelemimp = "selected='selected'"; break;
			case "nautic_metric": $selelemnaumet = "selected='selected'"; break;
			case "nautic_imperial": $selelemnauimp = "selected='selected'"; break;
			default: $selelemmet = "selected='selected'"; break;
		}
		echo "<option value='imperial' $selelemimp>Miles / Feet (imperial)</option>";
		echo "<option value='metric' $selelemmet>Kilometres / Metres (metric)</option>";
		echo "<option value='nautic_metric' $selelemnaumet>Nautical miles (Altitude: metres) (nautic_metric)</option>";
		echo "<option value='nautic_imperial' $selelemnauimp>Nautical miles (Altitude: feet) (nautic_imperial)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Measurement Type</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedscale; ?>">Speed Scale:</label></th>
		<td width="50%"><?php
		echo "<select onchange='enabling();' ";
		echo "name='".key_xmlgm_speedscale."' ";
		echo "id='".key_xmlgm_speedscale."'>";
		switch (get_option(key_xmlgm_speedscale))
		{
			case "level1": $selspeedl1 = "selected='selected'"; break;
			default: $selspeedl2 = "selected='selected'"; break;
		}
		echo "<option value='level1' $selspeedl1>Level 1 (level2)</option>";
		echo "<option value='level2' $selspeedl2>Level 2 (level1)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Speed Scale</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_kmlparsing; ?>">KML Parsing:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_kmlparsing."' ";
		echo "id='".key_xmlgm_kmlparsing."'>";
		switch (get_option(key_xmlgm_kmlparsing))
		{
			case "disabled": $selkmlpdis = "selected='selected'"; break;
			default: $selkmlpen = "selected='selected'"; break;
		}
		echo "<option value='enabled' $selkmlpen>Enabled (enabled)</option>";
		echo "<option value='disabled' $selkmlpdis>Diabled (disabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables parsing KML files. If this option is set to enabled, this plugin tries to parse the kml file for coordinates, set the center and zoomlevel to the perfect values. Parsing only works for KML links that ends with the file ending .kml, it won't work with the following notation [xmlgm {xyz.kml}]!</p>
		</td>
	</tr>	
</table>
<h3><a name="control"></a>Control Options</h3>
<p>Define the controls you want to display on your map</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_panzoomcontrol; ?>">Pan/Zoom Control:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_panzoomcontrol."' ";
		echo "id='".key_xmlgm_panzoomcontrol."'>";
		switch (get_option(key_xmlgm_panzoomcontrol))
		{
			case "hide": $selnonepz = "selected='selected'"; break;
			case "small": $selsmall = "selected='selected'"; break;
			case "zoom": $selzoom = "selected='selected'"; break;
			default: $sellarge = "selected='selected'"; break;
		}
		echo "<option value='hide' $selnonepz>Invisible (hide)</option>";
		echo "<option value='large' $sellarge>Large (large)</option>";
		echo "<option value='small' $selsmall>Small (small)</option>";
		echo "<option value='zoom' $selzoom>Zoom only (zoom)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Specifies the display style of the
		Pan/Zoom Control</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_overviewmap; ?>">Overview Map Control:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_overviewmap."' ";
		echo "id='".key_xmlgm_overviewmap."'>";
		switch (get_option(key_xmlgm_overviewmap))
		{
			case "show": $selshowom = "selected='selected'"; break;
			default: $selhideom = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhideom>Invisible (hide)</option>";
		echo "<option value='show' $selshowom>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Shows/Hides the overview map in the
		bottom right corner</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_scalecontrol; ?>">Scale Control:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_scalecontrol."' ";
		echo "id='".key_xmlgm_scalecontrol."'>";
		switch (get_option(key_xmlgm_scalecontrol))
		{
			case "show": $selshowsc = "selected='selected'"; break;
			default: $selhidesc = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidesc>Invisible (hide)</option>";
		echo "<option value='show' $selshowsc>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Shows/Hides the scale ruler in the bottom
		left corner</p>
		</td>
	</tr>
</table>
<h3><a name="maptype"></a>Map Type Options</h3>
<p>This optionset helps you to define all Map Type Option. Even the Map
Type Control options you can change.</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_viewstyle; ?>">Default Map Type:</label></th>
		<td width="50%"><?php
		echo "<select onchange='enabling();' ";
		echo "name='".key_xmlgm_viewstyle."' ";
		echo "id='".key_xmlgm_viewstyle."'>";
		switch (get_option(key_xmlgm_viewstyle))
		{
			case "G_SATELLITE_TYPE":
			case "G_SATELLITE_MAP":
				$selsat = "selected='selected'"; break;
			case "G_HYBRID_TYPE":
			case "G_HYBRID_MAP":
				$selhyb = "selected='selected'"; break;
			case "G_PHYSICAL_TYPE":
			case "G_PHYSICAL_MAP":
				$selphy = "selected='selected'"; break;
			case "G_SATELLITE_3D_TYPE":
			case "G_SATELLITE_3D_MAP":
				$selearth = "selected='selected'"; break;
			default:
				$selmap = "selected='selected'"; break;
		}
		echo "<option value='G_HYBRID_MAP' $selhyb>Hybrid (G_HYBRID_MAP)</option>";
		echo "<option value='G_SATELLITE_MAP' $selsat>Satellite (G_SATELLITE_MAP)</option>";
		echo "<option value='G_NORMAL_MAP' $selmap>Map (G_NORMAL_MAP)</option>";
		echo "<option value='G_PHYSICAL_MAP' $selphy>Physical (G_PHYSICAL_MAP)</option>";
		echo "<option value='G_SATELLITE_3D_MAP' $selearth>Google Earth Plugin (G_SATELLITE_3D_MAP)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Default Map Display Style</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_maptypecontrol; ?>">Map Type Control:</label>
		</th>
		<td width="50%"><?php
		echo "<select onchange='enabling();'";
		echo "name='".key_xmlgm_maptypecontrol."' ";
		echo "id='".key_xmlgm_maptypecontrol."'>";
		switch (get_option(key_xmlgm_maptypecontrol))
		{
			case "hide": $selhidemtc = "selected='selected'"; break;
			case "hierarchical": $selhidemhier = "selected='selected'"; break;
			default: $selshowmtc = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemtc>Invisible (hide)</option>";
		echo "<option value='show' $selshowmtc>Visible Default (show)</option>";
		echo "<option value='hierarchical' $selhidemhier>Visible Hierarchical Control (hierarchical)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Map Type Control</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_mapnorm; ?>">Normal Map Type Button:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_mapnorm."' ";
		echo "id='".key_xmlgm_mapnorm."'>";
		switch (get_option(key_xmlgm_mapnorm))
		{
			case "hide": $selhidemapnorm = "selected='selected'"; break;
			default: $selshowmapnorm = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemapnorm>Invisible (hide)</option>";
		echo "<option value='show' $selshowmapnorm>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Normal Map Type Button</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_mapsat; ?>">Satellite Map Type Button:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_mapsat."' ";
		echo "id='".key_xmlgm_mapsat."'>";
		switch (get_option(key_xmlgm_mapsat))
		{
			case "hide": $selhidemapsat = "selected='selected'"; break;
			default: $selshowmapsat = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemapsat>Invisible (hide)</option>";
		echo "<option value='show' $selshowmapsat>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Satellite Map Type Button</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_maphyb; ?>">Hybrid Map Type Button:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_maphyb."' ";
		echo "id='".key_xmlgm_maphyb."'>";
		switch (get_option(key_xmlgm_maphyb))
		{
			case "hide": $selhidemaphyb = "selected='selected'"; break;
			default: $selshowmaphyb = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemaphyb>Invisible (hide)</option>";
		echo "<option value='show' $selshowmaphyb>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Hybrid Map Type Button</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_mapphy; ?>">Physical Map Type Button:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_mapphy."' ";
		echo "id='".key_xmlgm_mapphy."'>";
		switch (get_option(key_xmlgm_mapphy))
		{
			case "hide": $selhidemapphy = "selected='selected'"; break;
			default: $selshowmapphy = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemapphy>Invisible (hide)</option>";
		echo "<option value='show' $selshowmapphy>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Physical Map Type Button</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_mapearth; ?>">Google Earth Plugin Map Type
		Button:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_mapearth."' ";
		echo "id='".key_xmlgm_mapearth."'>";
		switch (get_option(key_xmlgm_mapearth))
		{
			case "hide": $selhidemapearth = "selected='selected'"; break;
			default: $selshowmapearth = "selected='selected'"; break;
		}
		echo "<option value='hide' $selhidemapearth>Invisible (hide)</option>";
		echo "<option value='show' $selshowmapearth>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Show/Hide Google Earth Plugin Map Type
		Button</p>
		</td>
	</tr>
</table>
<h3><a name="mapbehaviour"></a>Map Behaviour Options</h3>
<p>Customize the behaviour of the map (e.g. zoom behaviours).</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_dragging; ?>">Dragging:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_dragging."' ";
		echo "id='".key_xmlgm_dragging."'>";
		switch (get_option(key_xmlgm_dragging))
		{
			case "disabled": $seldraggingdis = "selected='selected'"; break;
			default: $seldraggingen = "selected='selected'"; break;
		}
		echo "<option value='disabled' $seldraggingdis>Disabled (disabled)</option>";
		echo "<option value='enabled' $seldraggingen>Enabled (enabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables the dragging of the map</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_doubleClickZoom; ?>">Double Click Zoom:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_doubleClickZoom."' ";
		echo "id='".key_xmlgm_doubleClickZoom."'>";
		switch (get_option(key_xmlgm_doubleClickZoom))
		{
			case "disabled": $seldczdis = "selected='selected'"; break;
			default: $seldczen = "selected='selected'"; break;
		}
		echo "<option value='disabled' $seldczdis>Disabled (disabled)</option>";
		echo "<option value='enabled' $seldczen>Enabled (enabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables double click to zoom in
		and out</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_continuousZoom; ?>">Continuous Zoom:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_continuousZoom."' ";
		echo "id='".key_xmlgm_continuousZoom."'>";
		switch (get_option(key_xmlgm_continuousZoom))
		{
			case "disabled": $selczdis = "selected='selected'"; break;
			default: $selczen = "selected='selected'"; break;
		}
		echo "<option value='disabled' $selczdis>Disabled (disabled)</option>";
		echo "<option value='enabled' $selczen>Enabled (enabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables continuous smooth
		zooming for select browsers</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_scrollWheelZoom; ?>">Scroll Wheel Zoom:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_scrollWheelZoom."' ";
		echo "id='".key_xmlgm_scrollWheelZoom."'>";
		switch (get_option(key_xmlgm_scrollWheelZoom))
		{
			case "disabled": $selswzdis = "selected='selected'"; break;
			default: $selswzen = "selected='selected'"; break;
		}
		echo "<option value='disabled' $selswzdis>Disabled (disabled)</option>";
		echo "<option value='enabled' $selswzen>Enabled (enabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables zooming using a mouse's
		scroll wheel</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_googleBar; ?>">Google Bar:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_googleBar."' ";
		echo "id='".key_xmlgm_googleBar."'>";
		switch (get_option(key_xmlgm_googleBar))
		{
			case "enabled": $selgben = "selected='selected'"; break;
			default: $selgbdis = "selected='selected'"; break;
		}
		echo "<option value='disabled' $selgbdis>Disabled (disabled)</option>";
		echo "<option value='enabled' $selgben>Enabled (enabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Enables/Disables he GoogleBar, an
		integrated search control, to the map. When enabled, this control
		takes the place of the default Powered By Google logo.</p>
		</td>
	</tr>
</table>
<h3><a name="gpx"></a>GPX Options</h3>
<p>Settings specific for GPX Files<br />Have a look at the <a href="#templ">Templates</a> Section, there you can set the look &amp; feel of your GPX Waypoint Markers!</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_linecolor; ?>">Line Color:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_linecolor."' ";
		echo "id='".key_xmlgm_linecolor."' ";
		echo "value='".get_option(key_xmlgm_linecolor)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line color of any Track
		or Route</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_linewidth; ?>">Line Width:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_linewidth."' ";
		echo "id='".key_xmlgm_linewidth."' ";
		echo "value='".get_option(key_xmlgm_linewidth)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line width of any Track
		or Route</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_lineopacity; ?>">Line Opacity:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_lineopacity."' ";
		echo "id='".key_xmlgm_lineopacity."' ";
		echo "value='".get_option(key_xmlgm_lineopacity)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line opacity (1-100) of
		any Track or Route</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_gpxview; ?>">GPX View Style:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_gpxview."' ";
		echo "id='".key_xmlgm_gpxview."'>";
		switch (get_option(key_xmlgm_gpxview))
		{
			case "wpt": $selwpt = "selected='selected'"; break;
			case "rte": $selrte = "selected='selected'"; break;
			case "trk": $seltrk = "selected='selected'"; break;
			default: $selall = "selected='selected'"; break;
		}
		echo "<option value='all' $selall>Everything (all)</option>";
		echo "<option value='wpt' $selwpt>Waypoints (wpt)</option>";
		echo "<option value='rte' $selrte>Routes (rte)</option>";
		echo "<option value='trk' $seltrk>Tracks (trk)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Shows only the selected part of the GPX
		File.</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_gpxdirectopenwplink; ?>">GPX Direct Open Waypoint Link:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_gpxdirectopenwplink."' ";
		echo "id='".key_xmlgm_gpxdirectopenwplink."'>";
		switch (get_option(key_xmlgm_gpxdirectopenwplink))
		{
			case "disabled": $seldowpdis = "selected='selected'"; break;
			case "click": $seldowpcli = "selected='selected'"; break;
			default: $seldowpdbl = "selected='selected'"; break;
		}
		echo "<option value='dblclick' $seldowpdbl>Doubleclick (dblclick)</option>";
		echo "<option value='click' $seldowpcli>Click (click)</option>";
		echo "<option value='disabled' $seldowpdis>Disabled (disabled)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">If a GPX Waypoint has a link-Element you can Doubleclick or Click the marker to directly open this link! If you want to disable this behaviour, set disabled!</p>
		</td>
	</tr>
	
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_gpxcssstyle; ?>">Waypoint CSS Style:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_gpxcssstyle."' ";
		echo "id='".key_xmlgm_gpxcssstyle."' ";
		echo "value='".get_option(key_xmlgm_gpxcssstyle)."' />\n";
		?>
		<p style="margin: 5px 10px;">Define the GPX Waypoints Info Window CSS
		Style! Have a look at the <a href="#templ">Templates</a> Section, it would be better to use these templates than this property!</p>
		</td>
	</tr>
</table>
<h3><a name="elev"></a>Elevation Chart Options</h3>
<p>Settings for the Elevation Chart (now supported by GPX Tracks only)</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elevationchart; ?>">Elevation Chart:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_elevationchart."' ";
		echo "id='".key_xmlgm_elevationchart."'>";
		switch (get_option(key_xmlgm_elevationchart))
		{
			case "hide": $selelevhide = "selected='selected'"; break;
			default: $selelevshow = "selected='selected'"; break;
		}
		echo "<option value='hide' $selelevhide>Invisible (hide)</option>";
		echo "<option value='show' $selelevshow>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Visibility of evelation chart for GPX
		tracks</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elevationtitle; ?>">Elevation Chart Title:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_elevationtitle."' ";
		echo "id='".key_xmlgm_elevationtitle."' ";
		echo "value='".get_option(key_xmlgm_elevationtitle)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the Elevation Chart Title (<b>do
		not use special chars</b>)</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elevationheight; ?>">Elevation Chart
		Height:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_elevationheight."' ";
		echo "id='".key_xmlgm_elevationheight."' ";
		echo "value='".get_option(key_xmlgm_elevationheight)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the height of the elevation chart!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elevlinecolor; ?>">Elevation Chart Line
		Color:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_elevlinecolor."' ";
		echo "id='".key_xmlgm_elevlinecolor."' ";
		echo "value='".get_option(key_xmlgm_elevlinecolor)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line color of the
		elevation charts line!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_elelinewidth; ?>">Elevation Chart Line
		Width:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_elelinewidth."' ";
		echo "id='".key_xmlgm_elelinewidth."' ";
		echo "value='".get_option(key_xmlgm_elelinewidth)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line width of the
		elevation chart</p>
		</td>
	</tr>
</table>
<h3><a name="speedchart"></a>Speed Chart Options</h3>
<p>Settings for the Speed Chart (now supported by GPX Tracks only)</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedchart; ?>">Speed Chart:</label></th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_speedchart."' ";
		echo "id='".key_xmlgm_speedchart."'>";
		switch (get_option(key_xmlgm_speedchart))
		{
			case "show": $selspeedshow = "selected='selected'"; break;
			default:  $selspeedhide = "selected='selected'"; break;
		}
		echo "<option value='hide' $selspeedhide>Invisible (hide)</option>";
		echo "<option value='show' $selspeedshow>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Visibility of speed chart for GPX tracks</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedcharttitle; ?>">Speed Chart Title:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_speedcharttitle."' ";
		echo "id='".key_xmlgm_speedcharttitle."' ";
		echo "value='".get_option(key_xmlgm_speedcharttitle)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the Speed Chart Title (<b>do not
		use special chars</b>)</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedheight; ?>">Speed Chart Height:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_speedheight."' ";
		echo "id='".key_xmlgm_speedheight."' ";
		echo "value='".get_option(key_xmlgm_speedheight)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the height of the speed chart!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedlinecolor; ?>">Speed Chart Line Color:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_speedlinecolor."' ";
		echo "id='".key_xmlgm_speedlinecolor."' ";
		echo "value='".get_option(key_xmlgm_speedlinecolor)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line color of the speed
		charts line!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_speedlinewidth; ?>">Speed Chart Line Width:</label>
		</th>
		<td width="50%"><?php
		echo "<input type='text' size='50' ";
		echo "name='".key_xmlgm_speedlinewidth."' ";
		echo "id='".key_xmlgm_speedlinewidth."' ";
		echo "value='".get_option(key_xmlgm_speedlinewidth)."' />\n";
		?>
		<p style="margin: 5px 10px;">Enter the default line width of the speed
		chart</p>
		</td>
	</tr>
</table>
<h3><a name="checkpoint"></a>Checkpoint Options</h3>
<p>Settings for the Checkpoints (now supported by GPX Tracks only). To
activate the checkpoint you have to set the
gpxcheckpointinterval-Parameter on every map. The
gpxcheckpointinterval-parameter defines the interval in km or mi between
every checkpoint!<br />Have a look at the <a href="#templ">Templates</a> section, there you can set the look &amp; feel of your Checkpoint Table!</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">

	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_checkpointmapmarkercolor; ?>">Checkpoint
		Map Marker Color:</label></th>
		<td width="50%"><?php
		echo "<select onchange='enabling();' ";
		echo "name='".key_xmlgm_checkpointmapmarkercolor."' ";
		echo "id='".key_xmlgm_checkpointmapmarkercolor."'>";
		switch (get_option(key_xmlgm_checkpointmapmarkercolor))
		{
			case "red": $selcpmred = "selected='selected'"; break;
			case "green": $selcpmgreen = "selected='selected'"; break;
			case "yellow": $selcpmyellow = "selected='selected'"; break;
			case "blue": $selcpmblue = "selected='selected'"; break;
			default: $selcpmred = "selected='selected'"; break;
		}
		echo "<option value='red' $selcpmred>Red (red)</option>";
		echo "<option value='green' $selcpmgreen>Green (green)</option>";
		echo "<option value='yellow' $selcpmyellow>Yellow (yellow)</option>";
		echo "<option value='blue' $selcpmblue>Blue (blue)</option>";
		echo "</select>\n";
		?> <img alt="Default Marker" id="cpmarker" name="cpmarker" src="" /> <img alt="Start Marker"
			id="cpmarker_start" name="cpmarker_start" src="" /> <img
			alt="End Marker" id="cpmarker_end" name="cpmarker_end" src="" />
		<p style="margin: 5px 10px;">Define the Marker Color for the
		Checkpoint</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_checkpointinterval; ?>">Checkpoint
		Interval:</label></th>
		<td width="50%"><?php
		echo "<input type='text' size='50' onchange='enabling();'";
		echo "name='".key_xmlgm_checkpointinterval."' ";
		echo "id='".key_xmlgm_checkpointinterval."' ";
		echo "value='".get_option(key_xmlgm_checkpointinterval)."' />\n";
		?>
		<p style="margin: 5px 10px;">Set the checkpoint interval (0=disabled)!</p>
		</td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_checkpointtable; ?>">Checkpoint Table:</label>
		</th>
		<td width="50%"><?php
		echo "<select ";
		echo "name='".key_xmlgm_checkpointtable."' ";
		echo "id='".key_xmlgm_checkpointtable."'>";
		switch (get_option(key_xmlgm_checkpointtable))
		{
			case "show": $selcptabshow = "selected='selected'"; break;
			default: $selcptabhide = "selected='selected'"; break;
		}
		echo "<option value='hide' $selcptabhide>Invisible (hide)</option>";
		echo "<option value='show' $selcptabshow>Visible (show)</option>";
		echo "</select>\n";
		?>
		<p style="margin: 5px 10px;">Visibility of checkpoint table
		(checkpointinterval has to be set to a value &gt;0)</p>
		</td>
	</tr>	
	</table>
<h3><a name="templ"></a>Templates</h3>
<p>Define the look &amp; feel of your Checkpoint Table, GPX marker or NextGEN Gallery marker!</p>
<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_checkpointtabletempl; ?>">Checkpoint Table
		Template:</label></th>
		<td width="50%"><?php
		echo "<textarea rows='15' cols='50' style='width: 100%;'";
		echo "name='".key_xmlgm_checkpointtabletempl."' ";
		echo "id='".key_xmlgm_checkpointtabletempl."'>";
		echo get_option(key_xmlgm_checkpointtabletempl)."</textarea>\n";
		?>
		<p style="margin: 5px 10px;">Define your own table template. Use the
		following parameters for placeholders:<br />
		%WIDTH% - Placeholder of the Width setting<br />
		%ROW% - Row Template Placeholder<br />
		%DISTANCE% - Distance of the track<br />
		%TIME% - Time of the track<br />
		%MOVINGTIME% - Time of the track (without breaks)<br />
		%SPEED% - Average Speed of the track<br />
		%MOVINGSPEED% - Average Speed of the track (without breaks)<br />		
		%MAXSPEED% - Max Speed of the track<br />
		%CLIMBUP% - Climb Up of the track<br />
		%CLIMBDOWN% - Climb Down of the track<br />
		<br />
		Delete the whole content to restore the default value!</p>
		</td>
		<?php echo $navigation; ?>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_checkpointtablerowtempl; ?>">Checkpoint
		Table Row Template:</label></th>
		<td width="50%"><?php
		echo "<textarea rows='15' cols='50' style='width: 100%;'";
		echo "name='".key_xmlgm_checkpointtablerowtempl."' ";
		echo "id='".key_xmlgm_checkpointtablerowtempl."'>";
		echo get_option(key_xmlgm_checkpointtablerowtempl)."</textarea>\n";
		?>
		<p style="margin: 5px 10px;">Define your own row template. Use the
		following parameters for placeholders:<br />
		%MARKERIMAGEURL% - URL to the checkpoint Image <br />
		%CHECKPOINTNUMBER% - Number of the Checkpoint <br />
		%PARTDISTANCE% - Distance between checkpoints<br />
		%PARTTIME% - Timedifference between checkpoints<br />
		%PARTMOVINGTIME% - Timedifference between checkpoints (without breaks)<br />
		%PARTSPEED% - Average speed between checkpoints<br />
		%PARTMOVINGSPEED% - Average speed between checkpoints (without breaks)<br />
		%PARTMAXSPEED% - Max Speed between checkpoints<br />
		%PARTCLIMBUP% - Climb Up checkpoints<br />
		%PARTCLIMBDOWN% - Climb Down checkpoints<br />				
		%DISTANCE% - Distance from starting point<br />
		%TIME% - Time from the starting point<br />
		%MOVINGTIME% - Time from the starting point (without breaks)<br />		
		%SPEED% - Average Speed from the starting point<br />
		%MOVINGSPEED% - Average Speed from the starting point (without breaks)<br />
		%MAXSPEED% - Max Speed from the starting point<br />
		%CLIMBUP% - Climb Up from the starting point<br />
		%CLIMBDOWN% - Climb Down from the starting point<br />
		%LATITUDE% - Latitude Information of the Checkpoint<br />
		%LONGITUDE% - Longitude Information of the Checkpoint<br />
		%ELEVATION% - Elevation Information of the Checkpoint<br />				
		<br />
		Delete the whole content to restore the default value!</p></td>
	</tr>
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_gpxmarkertempl; ?>">GPX Waypoint Marker Template:</label></th>
		<td width="50%"><?php
		echo "<textarea rows='15' cols='50' style='width: 100%;'";
		echo "name='".key_xmlgm_gpxmarkertempl."' ";
		echo "id='".key_xmlgm_gpxmarkertempl."'>";
		echo get_option(key_xmlgm_gpxmarkertempl)."</textarea>\n";
		?>
		<p style="margin: 5px 10px;">Define your own row template. Use the
		following parameters for placeholders:<br />
		%DESCRIPTION% - DESC Tag of the GPX Waypoint <br />
		%NAME% - NAME Tag of the GPX Waypoint <br />
		%LINK% - Attribute HREF of the LINK Tag of the GPX Waypoint <br />
		%LATITUDE% - Latitude Information of the GPX Waypoint<br />
		%LONGITUDE% - Longitude Information of the GPX Waypoint<br />
		%ELEVATION% - Elevation Information of the GPX Waypoint<br />		
		<br />
		Delete the whole content to restore the default value!</p></td>
	</tr>	
	<tr>
		<th valign="top" style="padding-top: 10px;" width="35%"><label
			for="<?php echo key_xmlgm_nggmarkertempl; ?>">NextGEN Gallery Image Marker Template:</label></th>
		<td width="50%"><?php
		echo "<textarea rows='15' cols='50' style='width: 100%;'";
		echo "name='".key_xmlgm_nggmarkertempl."' ";
		echo "id='".key_xmlgm_nggmarkertempl."'>";
		echo get_option(key_xmlgm_nggmarkertempl)."</textarea>\n";
		?>
		<p style="margin: 5px 10px;">Define your own row template. Use the
		following parameters for placeholders:<br />
		%FULLPATH% - Full Image Path <br />
		%THUMBPATH% - Thumb Image Path <br />
		%TITLE% - Title of the image <br />
		%DESCRIPTION% - Description of the Image <br />
		%CREATIONDATE% - Creation Date of the Image <br />
		%LATITUDE% - Latitude Information of the Image<br />
		%LONGITUDE% - Longitude Information of the Image<br />
		<br />
		Delete the whole content to restore the default value!</p></td>
	</tr>		
</table>
</div>
</form>
<script type="text/javascript">
		<!--
			enabling();
		-->
		</script>
		<?php
}

function xmlgm_nonce_field() {
	echo "<input type='hidden' name='xmlgm-nonce-key' value='" . wp_create_nonce('xml-google-maps') . "' />";
}

function getDisplayURL($urldisplaymode, $displayurl, $varstring) {
	switch ($urldisplaymode) {
		case "none":
			$displayurl = "";
			break;
		case "showvars":
			$displayurl = $displayurl;
			break;
		case "nomap":
			$displayurl = str_replace("[".$varstring."]","",$displayurl);
			break;
		default:
			$displayurl = str_replace("[".$varstring."]","",$displayurl);
			break;
	}
	return $displayurl;
}

// Not exististing Functions
if(!function_exists("stripos"))
{
	function stripos($str, $needle)
	{
		return strpos(strtolower($str),strtolower($needle));
	}
}

?>